#include "lcd.h"
#include <avr/io.h>
#include <util/delay.h>

#define MORSE_LUNG  3
#define MORSE_SCURT 1

void speaker_morse(int tip)
{

    int delay = 1;
    int i;
	
	//portul pe care e setat buzzer-ul
    DDRD |= (1 << PD5);

    for (i = 0; i < tip * 200 / delay; i++)
    {
        PORTD ^= (1 << PD5);
        _delay_ms(1);
    }
	
}

void test()
{

    //configurare porturi folosite pentru butoane
	//activarea rezistentei de pull-up
    DDRB &= ~((1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4) | (1 << PB5));
    PORTB |= (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4) | (1 << PB5);

    LCD_print("Aloha!");

    uint8_t PINB_old = 0xff;

    for(;;)
    {
        uint8_t PINB_crt = PINB;
		
        if((PINB_old & (1 << PB1)) && !(PINB_crt & (1 << PB1)))
        {
            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_print("B1");
        }
        
        if((PINB_old & (1 << PB2)) && !(PINB_crt & (1 << PB2)))
        {
            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_print("B2");
        }
		
        if((PINB_old & (1 << PB3)) && !(PINB_crt & (1 << PB3)))
        {
            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_print("B3");
        }
		
        if((PINB_old & (1 << PB4)) && !(PINB_crt & (1 << PB4)))
        {
			speaker_morse(MORSE_SCURT);
            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_print("B4");
        }
		
        if((PINB_old & (1 << PB5)) && !(PINB_crt & (1 << PB5)))
        {
			speaker_morse(MORSE_LUNG);
            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_print("B5");
        }

        PINB_old = PINB_crt;

        _delay_ms(5);
    }

}

int main()
{
	
	LCD_init();
	test();

	return 0;

}
